import { FormControl, FormGroup, FormArray, FormBuilder, ReactiveFormsModule } from '@angular/forms';
import { Injectable, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AutomaticFormBuilder = /** @class */ (function () {
    function AutomaticFormBuilder(formbuilder) {
        this.group = formbuilder.group;
        this.control = formbuilder.control;
        this.array = formbuilder.array;
    }
    /**
     * @param {?} options
     * @return {?}
     */
    AutomaticFormBuilder.prototype.setupForm = /**
     * @param {?} options
     * @return {?}
     */
    function (options) {
        /** @type {?} */
        var formGroup;
        if (this.isObject(options)) {
            formGroup = this.group({});
            this.setupGroup(formGroup, options);
        }
        return formGroup;
    };
    /**
     * @param {?} form
     * @param {?} options
     * @return {?}
     */
    AutomaticFormBuilder.prototype.setupGroup = /**
     * @param {?} form
     * @param {?} options
     * @return {?}
     */
    function (form, options) {
        for (var opt in options) {
            if (Array.isArray(options[opt])) {
                /** @type {?} */
                var controlOptions = (/** @type {?} */ (options[opt]));
                /** @type {?} */
                var validate = false;
                /** @type {?} */
                var asyncValidate = false;
                if (Array.isArray(controlOptions[1])) {
                    validate = true;
                }
                if (Array.isArray(controlOptions[2])) {
                    asyncValidate = true;
                }
                /** @type {?} */
                var ctrl = (/** @type {?} */ (new FormControl(controlOptions[0], validate ? controlOptions[1] : [], asyncValidate ? controlOptions[2] : [])));
                if (this.isObject(controlOptions[3])) {
                    /** @type {?} */
                    var ext = (/** @type {?} */ (options[opt][3]));
                    ctrl.errormsg = ext.errormsg;
                    ctrl.type = ext.type;
                    ctrl.label = ext.label;
                }
                form.addControl(opt, ctrl);
            }
            else {
                if (this.isObject(options[opt])) {
                    /** @type {?} */
                    var subG = this.group({});
                    form.addControl(opt, subG);
                    this.setupGroup((/** @type {?} */ (form.get(opt))), (/** @type {?} */ (options[opt])));
                }
            }
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    AutomaticFormBuilder.prototype.isObject = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return (typeof value === 'object' && value !== null && value.length === undefined);
    };
    /**
     * @param {?} val
     * @return {?}
     */
    AutomaticFormBuilder.prototype.isValidValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return (typeof val === 'string' ||
            typeof val === 'number' ||
            typeof val === 'boolean');
    };
    /**
     * @param {?} controlsConfig
     * @return {?}
     */
    AutomaticFormBuilder.prototype._reduceControls = /**
     * @param {?} controlsConfig
     * @return {?}
     */
    function (controlsConfig) {
        var _this = this;
        /** @type {?} */
        var controls = {};
        Object.keys(controlsConfig).forEach((/**
         * @param {?} controlName
         * @return {?}
         */
        function (controlName) {
            controls[controlName] = _this._createControl(controlsConfig[controlName]);
        }));
        return controls;
    };
    /**
     * @param {?} controlConfig
     * @return {?}
     */
    AutomaticFormBuilder.prototype._createControl = /**
     * @param {?} controlConfig
     * @return {?}
     */
    function (controlConfig) {
        if (controlConfig instanceof FormControl ||
            controlConfig instanceof FormGroup ||
            controlConfig instanceof FormArray) {
            return controlConfig;
        }
        else if (Array.isArray(controlConfig)) {
            /** @type {?} */
            var value = controlConfig[0];
            /** @type {?} */
            var validator = controlConfig.length > 1 ? controlConfig[1] : null;
            /** @type {?} */
            var asyncValidator = controlConfig.length > 2 ? controlConfig[2] : null;
            return this.control(value, validator, asyncValidator);
        }
        else {
            return this.control(controlConfig);
        }
    };
    AutomaticFormBuilder.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    AutomaticFormBuilder.ctorParameters = function () { return [
        { type: FormBuilder }
    ]; };
    return AutomaticFormBuilder;
}());
if (false) {
    /** @type {?} */
    AutomaticFormBuilder.prototype.array;
    /** @type {?} */
    AutomaticFormBuilder.prototype.control;
    /** @type {?} */
    AutomaticFormBuilder.prototype.group;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AutomaticFormbuilderModule = /** @class */ (function () {
    function AutomaticFormbuilderModule() {
    }
    AutomaticFormbuilderModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [],
                    imports: [ReactiveFormsModule],
                    providers: [AutomaticFormBuilder],
                    exports: [ReactiveFormsModule]
                },] }
    ];
    return AutomaticFormbuilderModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFormControlErrorMsg() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IExtFormControlSettings() { }
if (false) {
    /** @type {?} */
    IExtFormControlSettings.prototype.type;
    /** @type {?|undefined} */
    IExtFormControlSettings.prototype.label;
    /** @type {?|undefined} */
    IExtFormControlSettings.prototype.errormsg;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFormSettings() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AutomaticFormBuilder, AutomaticFormbuilderModule };
//# sourceMappingURL=ngx-automatic-formbuilder.js.map
